#!/usr/bin/env python
# The World Dissolved: Act 0
# An Interactive Novel by Phil Bordelon
#

import tools

flavour = tools.flavour

def Help():
   """Print game help text."""
   print
   print "This game is an interactive novel."
   print "You may quit at any time by entering 'Q' as your command."
   print "You may save at any time by entering 'S' as your command."
   print "You may load your save at any time by entering 'L' as your command."
   print "You can redisplay a location by entering '?' as your command."
   print "Otherwise, the words in capital letters are actions you can try."
   print "(You don't need to type them in capital letters.)"
   print
   tools.hitEnter()
   print

def IntroDeskRead(state):
   flavour("intro.desk.read")
   state.global_state["read-coombs-file"] = True
   flavour("intro.desk.phone")
   state.global_state["allowed-action-dict"]["intro.desk"] = ["stand"]

def IntroDeskStand(state):
   if not state.global_state.get("read-coombs-file"):
      flavour("intro.desk.stand")
   else:
      flavour("intro.leave")
      flavour("act-1")
      state.move("marsh.car")

def init(state):
   state.location_dict["intro"] = {
      "name": "intro",
      "text": "intro",
      "can-brief": True,
      "actions": [("look", "LOOK out the window.", flavour, "intro.window"),
                  ("sit", "SIT at the desk.", state.move, "intro.desk"),
                  ("help", "Get HELP on playing this.  (Type HELP.)", Help)]
   }
   state.location_dict["intro.desk"] = {
      "name": "intro.desk",
      "text": "intro.desk",
      "can-brief": True,
      "actions": [("read", "READ over the Coombs file.", IntroDeskRead, state),
                  ("dig", "DIG in the drawers for another bottle.", flavour, "intro.desk.dig"),
                  ("stand", "STAND up.", IntroDeskStand, state)]
   }
