#!/usr/bin/env python
# The World Dissolved: Act 1 (Coombs Estate)
# An Interactive Novel by Phil Bordelon

import tools

flavour = tools.flavour

def Act1CoombsPage(state):
   flavour("act1.coombs.page")
   state.move("act1.coombs.foyer")

def Act1CoombsLeave(state):
   if state.global_state.get("know-about-corpse-etching"):
      flavour("act1.coombs.leaving.know")
      state.move("act1.driving")
   else:
      flavour("act1.coombs.leaving.no")

def Act1DanaWhy(state):
   flavour("act1.coombs.dana.why")
   state.global_state["allowed-action-dict"]["act1.coombs.dana"].remove("why")
   state.global_state["allowed-action-dict"]["act1.coombs.dana"].append("how")

def Act1DanaHow(state):
   flavour("act1.coombs.dana.how")
   state.global_state["allowed-action-dict"]["act1.coombs.dana"].remove("how")
   state.global_state["allowed-action-dict"]["act1.coombs.dana"].append("anything")

def Act1DanaAnything(state):
   flavour("act1.coombs.dana.anything")
   state.global_state["know-about-corpse-etching"] = True
   state.global_state["allowed-action-dict"]["act1.coombs.dana"].remove("anything")

def init(state):
   state.location_dict["act1.coombs.front-gate"] = {
      "name": "act1.coombs.front-gate",
      "text": "act1.coombs.front-gate",
      "actions": [("page", "PAGE the Coombs'.", Act1CoombsPage, state)]
   }

   state.location_dict["act1.coombs.foyer"] = {
      "name": "act1.coombs.foyer",
      "text": "act1.coombs.foyer",
      "can-brief": True,
      "actions": [("talk", "TALK to Dana Coombs.", state.move, "act1.coombs.dana"),
                  ("hallway", "Enter the side HALLWAY.", flavour, "act1.coombs.hallway"),
                  ("leave", "LEAVE.", Act1CoombsLeave, state)]
   }

   state.location_dict["act1.coombs.dana"] = {
      "name": "act1.coombs.dana",
      "text": "act1.coombs.dana",
      "no-prompt": True,
      "actions": [("why", "WHY didn't you tell me about her boyfriend?", Act1DanaWhy, state),
                  ("how", "HOW did she have a boyfriend and you not know?", Act1DanaHow, state),
                  ("anything", "Is there ANYTHING you might know about this guy?", Act1DanaAnything, state),
                  ("goodbye", "GOODBYE, Dana.", state.move, "act1.coombs.foyer")]
   }
   state.global_state["allowed-action-dict"]["act1.coombs.dana"] = ["why", "goodbye"]
