#!/usr/bin/env python
# The World Dissolved: Act 1 (Marsh)
# An Interactive Novel by Phil Bordelon
#

import tools

flavour = tools.flavour

def MarshCarNo(state):
   flavour("marsh.car.no")
   state.global_state["pearce-mood"] = -1
   state.move("marsh.near-cars")

def MarshCarYes(state):
   flavour("marsh.car.yes")
   state.global_state["pearce-mood"] = 0
   state.move("marsh.near-cars")

def MarshNearCarsHead(state):
   flavour("marsh.near-cars.head")
   state.move("marsh.body")

def MarshBodyExamine(state):
   if not state.global_state.get("body-examine-count"):
      state.global_state["body-examine-count"] = 1
      flavour("marsh.body.examine.1")
   else:
      ecount = state.global_state["body-examine-count"]
      if ecount == 1:
         if not state.global_state.get("body-pearce-count"):
            flavour("marsh.body.examine.no")
         else:
            state.global_state["body-examine-count"] = 2
            flavour("marsh.body.examine.2")
      else:
         flavour("marsh.body.examine.no")

def MarshBodyTalk(state):
   if not state.global_state.get("body-examine-count"):
      flavour("marsh.body.talk.no")
   else:
      if not state.global_state.get("body-pearce-count"):
         flavour("marsh.body.talk.1")
         state.global_state["body-pearce-count"] = 1
      elif state.global_state.get("body-pearce-count") == 1 and state.global_state.get("body-examine-count") == 2:
         flavour("marsh.body.talk.2")
         state.global_state["pearce-mood"] += 1
         state.global_state["body-pearce-count"] = 2
      else:
         flavour("marsh.body.talk.no")

def MarshBodyReturn(state):
   ecount = state.global_state.get("body-examine-count")
   if not ecount or ecount < 2:
      flavour("marsh.body.return.no")
   else:
      state.move("marsh.near-cars-2")

def MarshPearceWhat(state):
   flavour("marsh.pearce-talk.what")
   state.global_state["pearce-talked-near-cars"] = True
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].append("how")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].remove("what")

def MarshPearceHow(state):
   flavour("marsh.pearce-talk.how")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].append("who")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].append("talk")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].remove("how")

def MarshPearceWho(state):
   flavour("marsh.pearce-talk.who")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].remove("who")
   state.global_state["pearce-mood"] -= 1

def MarshPearceTalk(state):
   if state.global_state["pearce-mood"] >= 1:
      flavour("marsh.pearce-talk.talk.yes")
      state.global_state["pearce-going-to-talk"] = True
      state.global_state["pearce-mood"] += 1
   else:
      flavour("marsh.pearce-talk.talk.no")
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"].remove("talk")

def MarshLeavingCheckPearceTalk(state):
   if state.global_state.get("pearce-going-to-talk"):
      state.global_state["allowed-action-dict"]["marsh.leaving"].append("reassure")
   elif not state.global_state.get("pearce-talked-near-cars"):
      state.global_state["pearce-mood"] -= 2

def MarshLeavingReassure(state):
   flavour("marsh.leaving.reassure")
   state.global_state["pearce-mood"] += 1
   state.global_state["allowed-action-dict"]["marsh.leaving"].remove("reassure")

def init(state):
   state.location_dict["marsh.car"] = {
      "name": "marsh.car",
      "text": "marsh.car",
      "no-prompt": True,
      "actions": [("no", '"NO, not particularly.  Just thought I\'d drive out here."', MarshCarNo, state),
                  ("yes", '"YES, of course.  Just give me a second."', MarshCarYes, state)]
   }
   
   state.location_dict["marsh.near-cars"] = {
      "name": "marsh.near-cars",
      "text": "marsh.near-cars",
      "can-brief": True,
      "actions": [("head", "HEAD towards Pearce.", MarshNearCarsHead, state),
                  ("look", "LOOK at Pearce's car.", flavour, "marsh.near-cars.pearce-car"),
                  ("return", "RETURN to your car.", flavour, "marsh.near-cars.return")]

   }
   
   state.location_dict["marsh.body"] = {
      "name": "marsh.body",
      "text": "marsh.body",
      "can-brief": True,
      "actions": [("examine", "EXAMINE the body.", MarshBodyExamine, state),
                  ("talk", "TALK to Pearce.", MarshBodyTalk, state),
                  ("return", "RETURN to the cars.", MarshBodyReturn, state)]
   }
   
   state.location_dict["marsh.near-cars-2"] = {
      "name": "marsh.near-cars-2",
      "text": "marsh.near-cars-2",
      "can-brief": True,
      "actions": [("talk", "TALK to Pearce.", state.move, "marsh.pearce-talk"),
                  ("leave", "LEAVE.", state.move, "marsh.leaving")]
   }
   
   state.location_dict["marsh.pearce-talk"] = {
      "name": "marsh.pearce-talk",
      "text": "marsh.pearce-talk",
      "no-prompt": True,
      "can-brief": True,
      "actions": [("what", '"WHAT do you really think happened here?"', MarshPearceWhat, state),
                  ("how", '"HOW do you think this happened?"', MarshPearceHow, state),
                  ("who", '"WHO do you think is involved?"', MarshPearceWho, state),
                  ("talk", '"This is bothering you, I know.  Do you want to TALK?"', MarshPearceTalk, state),
                  ("later", '"LATER, Pearce."', state.move, "marsh.near-cars-2")]
   }
   state.global_state["allowed-action-dict"]["marsh.pearce-talk"] = ["what", "later"]

   state.location_dict["marsh.leaving"] = {
      "name": "marsh.leaving",
      "text": "marsh.leaving",
      "can-brief": True,
      "pre-function": [MarshLeavingCheckPearceTalk, state],
      "actions": [("drive", "DRIVE away from this god-forsaken place.", state.move, "act1.driving"),
                  ("reassure", "REASSURE Pearce that you'll be there.", MarshLeavingReassure, state)]
   }
   state.global_state["allowed-action-dict"]["marsh.leaving"] = ["drive"]
