#!/usr/bin/env python
# The World Dissolved: Act 1 (Office)
# An Interactive Novel by Phil Bordelon

import tools

flavour = tools.flavour

def Act1OfficeCheckLights(state):
   if not state.global_state.get("act1-office-lights-on"):
      state.location_dict["act1.office"]["text"] = "act1.office.dark"
   else:
      state.location_dict["act1.office"]["text"] = "act1.office.light"

def Act1OfficeLights(state):
   if not state.global_state.get("act1-office-breaker-flipped"):
      flavour("act1.office.turn.no")
      if "outside" not in state.global_state["allowed-action-dict"]["act1.office"]:
         state.global_state["allowed-action-dict"]["act1.office"].append("outside")
   else:
      flavour("act1.office.turn.yes")
      state.global_state["act1-office-lights-on"] = True
      state.location_dict["act1.office"]["brief"] = False
      state.global_state["allowed-action-dict"]["act1.office"].append("reread")
      state.global_state["allowed-action-dict"]["act1.office"].remove("turn")

def Act1OfficeOutside(state):
   if not state.global_state.get("act1-office-breaker-flipped"):
      state.move("act1.office.outside")
   elif state.global_state.get("know-about-boyfriend"):
      flavour("act1.office.leaving")
      state.global_state["done-with-office"] = True
      state.move("act1.driving")
   else:
      flavour("act1.office.leaving.no")

def Act1OfficeReread(state):
   if not state.global_state.get("reread-coombs-file"):
      flavour("act1.office.reread")
      state.global_state["allowed-action-dict"]["act1.office"].append("call")
      state.global_state["reread-coombs-file"] = True
   else:
      flavour("act1.office.reread.no")

def Act1OfficeCall(state):
   flavour("act1.office.call")
   state.global_state["know-about-boyfriend"] = True
   state.global_state["allowed-action-dict"]["act1.office"].remove("call")

def Act1OfficeFlip(state):
   flavour("act1.office.flip")
   state.global_state["act1-office-breaker-flipped"] = True
   state.move("act1.office")

def init(state):
   state.location_dict["act1.office"] = {
      "name": "act1.office",
      "text": "act1.office.dark",
      "can-brief": True,
      "pre-function": [Act1OfficeCheckLights, state],
      "actions": [("turn", "TURN on the lights.", Act1OfficeLights, state),
                  ("outside", "Go OUTSIDE.", Act1OfficeOutside, state),
                  ("reread", "REREAD the Coombs case file.", Act1OfficeReread, state),
                  ("call", "CALL the Coombs'.", Act1OfficeCall, state)]
   }
   state.global_state["allowed-action-dict"]["act1.office"] = ["turn"]

   state.location_dict["act1.office.outside"] = {
      "name": "act1.office.outside",
      "text": "act1.office.outside",
      "actions": [("flip", "FLIP the breaker.", Act1OfficeFlip, state)]
   }
